#! /usr/bin/env python
#****************************************************
# GET LIBRARY - Do not modify this section
#****************************************************
import os
from gslab_make.get_externals import *
from gslab_make.get_externals_github import *
from gslab_make.make_links import *
from gslab_make.make_link_logs import *
from gslab_make.make_log import *
from gslab_make.run_program import *
from gslab_make.dir_mod import *

#****************************************************
# MAKE.PY STARTS: 
#****************************************************
set_option(link_logs_dir = '../output/')
clear_dirs( '../output/', '../temp/', \
            '../external/', '../external_links/')
start_make_logging()

os.mkdir('../output/tables/')
os.mkdir('../output/figures/')
os.mkdir('../temp/data/')

# GET_EXTERNALS
get_externals('externals.txt')

# MAKE LINKS
make_links('./links.txt')
make_link_logs('./links.txt')

# ANALYSIS
run_stata(program = 'analysis.do')

end_make_logging()

raw_input('\n Press <Enter> to exit.')
