version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado

preliminaries

program main

    forvalues Y = 1998/2014 {
        local y = substr("`Y'",-2,.)
        insheet using "../external/geo/ziphsahrr`y'.csv", clear
        rename zipcode`y' zipcode
        gen year = `Y'
        format zipcode %05.0f
        tostring zipcode, u replace
        save ../temp/xw`Y', replace
    }
    clear
    forvalues Y = 1998/2014 {
        append using ../temp/xw`Y'
    }
    save ../temp/xw_all, replace

    bys zipcode: egen keep = min(year)
    replace keep = (keep==1998)
    drop year
    collapse (firstnm) hsanum hsacity hsastate hrrnum hrrcity hrrstate keep, by(zipcode)

    save_data ../output/ziphrrxwalk.csv, outsheet delim(",") replace key(zipcode)

    label var zipcode "Zip Code"
    label var hsanum "Hospital Service Area"
    label var hsacity "HSA City"
    label var hsastate "HSA State"
    label var hrrnum "Hospital Referral Region"
    label var hrrcity "HRR City"
    label var hrrstate "HRR State"        
    label var keep "I:Zipcode appears in 1998 crosswalk. We only use these zipcodes"        

    save_data ../output/ziphrrxwalk.dta, replace key(zipcode)

end

* EXECUTE
main
