version 12
adopath + ../external/lib/stata/gslab_misc/ado 
adopath + ../external/lib/stata/ado 
preliminaries

program main
    medpar_sample_restrictions, ///
        samp(post) ///
        year_restrictions((year(dschrgdt) > 2007 & year(dschrgdt) < 2012) | ///
            (year(dschrgdt) == 2007 & month(dschrgdt) >= 10) | ///
            (year(dschrgdt) == 2012 & month(dschrgdt) <= 7))

    medpar_sample_restrictions, ///
        samp(pre) ///
        year_restrictions((year(dschrgdt) >= 2000 & year(dschrgdt) < 2002) | ///
            (year(dschrgdt) == 2002 & month(dschrgdt) <= 9))


end

program medpar_sample_restrictions
    syntax, samp(string) year_restrictions(string) 

    use ../external_links/compiled/compiled_ltch_stays_`samp', clear
    keep if `year_restrictions'

    * Drop Calvary
    drop if prvdrnum=="332006"

    if "`samp'" == "post" { 
        tab pps_ind
        keep if pps_ind == 2
    }
    destring sex race, replace
    save_data ../output/medpar_sample_`samp', replace key(medparid year)
end

*Execute
main
