#! /usr/bin/env python
#****************************************************
# GET LIBRARY
#****************************************************
import subprocess, shutil, os
gslab_make_path = os.getenv('gslab_make_path')
subprocess.call('svn export --force -r 2595 file:///disk/agedisk4/medicare.work/finkels-DUA22559/svn/trunk/lib/python/gslab_make/ gslab_make', shell = True)
from gslab_make.py.get_externals import *
from gslab_make.py.make_links import *
from gslab_make.py.make_log import *
from gslab_make.py.run_program import *
from gslab_make.py.dir_mod import *

#****************************************************
# MAKE.PY STARTS
#****************************************************
set_option(link_logs_dir = '../output/')
clear_output_dirs()
start_make_logging()

# GET_EXTERNALS
get_externals('externals.txt')

# MAKE_LINKS
make_links('links.txt')

# GENERATE INPUT FILES FOR CGS
run_stata(program = 'input.do')

# SET UP CGS OUTPUT FILES
file=open('../output/error_log_v17.txt', 'w')
file.close()
file=open('../output/error_log_v18.txt', 'w')
file.close()
file=open('../output/error_log_v19.txt', 'w')
file.close()
file=open('../temp/output_v17.csv', 'w')
file.close()
file=open('../temp/output_v18.csv', 'w')
file.close()
file=open('../temp/output_v19.csv', 'w')
file.close()

# RUN CGS
subprocess.call("bash cgs_commandline_v17", shell=True)
subprocess.call("bash cgs_commandline_v18", shell=True)
subprocess.call("bash cgs_commandline_v19", shell=True)


# COMPILE CGS OUTPUT
run_stata(program = 'output.do')

# CHECK DTA (AND CSV, TXT FILES) IN MANIFEST LOG
end_make_logging()

shutil.rmtree('gslab_make')
raw_input('\n Press <Enter> to exit.')
