version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
preliminaries

global min_sample_year = 1998
global max_sample_year = 2014


program main
    append_denom
    generate_deathlist
end

program append_denom
    forval year=${min_sample_year}/${max_sample_year} {
        use bene_id death_dt using ../external/denom/bsfab`year', clear
        gen record_year = `year'
        drop if death_dt==.
        save ../temp/deathdts`year', replace
    }
    clear
    forval year=${min_sample_year}/${max_sample_year} {
        append using ../temp/deathdts`year'
    }
    save ../temp/deathdts, replace
end


program generate_deathlist
    use ../temp/deathdts, clear
    *in case death dates disagree across years, follow the more recent record
    gsort bene_id -record_year
    by bene_id: keep if _n == 1
    drop record_year
    save_data ../output_local/deathlist${min_sample_year}_${max_sample_year}, ///
        replace key(bene_id) log("../output/data_file_manifest.log")
end


*Execute
main
