*!version 7.0.7  11Aug2016 

capture program drop rdplot
program define rdplot, eclass
	syntax anything [if] [, c(real 0) p(integer 4) kernel(string) h(string) k(real 4) binselect(string) scale(string) nbins(string) generate(string) graph_options(string) ci(real 0) shade hide nochecks *]

	marksample touse

	tokenize "`anything'"
	local y `1'
	local x `2'
	
	***********************************************************
	tokenize `generate'	
	local w : word count `generate'
	if `w' == 1 {
		confirm new var `1'	
		local id_var `"`1'"'
		local nsave 1
	}
	if `w' == 2 {
		confirm new var `1'	
		confirm new var `2'
		local id_var `"`1'"'
		local meanx_var `"`2'"'
		local nsave 2
	}
	if `w' == 3 {
		confirm new var `1'	
		confirm new var `2'
		confirm new var `3'
		local id_var    `"`1'"'
		local meanx_var `"`2'"'
		local meany_var `"`3'"'
		local nsave 3
	}
	if `w' == 5 {
		confirm new var `1'	
		confirm new var `2'
		confirm new var `3'
		confirm new var `4'
		confirm new var `5'
		local id_var    `"`1'"'
		local meanx_var `"`2'"'
		local meany_var `"`3'"'
		local cil_var   `"`4'"'
		local cir_var   `"`5'"'
		local nsave 5
	}
	******************** Set BW ***************************
	tokenize `h'	
	local w : word count `h'
	if `w' == 1 {
		local h_r = `"`1'"'
		local h_l = `"`1'"'
	}
	if `w' == 2 {
		local h_l `"`1'"'
		local h_r `"`2'"'
	}
	if `w' >= 3 {
		di as error  "{err}{cmd:h()} accepts at most two inputs"  
		exit 125
	}
	******************** Set scale ***************************
	tokenize `scale'	
	local w : word count `scale'
	if `w' == 1 {
		local scale_r = `"`1'"'
		local scale_l = `"`1'"'
	}
	if `w' == 2 {
		local scale_l `"`1'"'
		local scale_r `"`2'"'
	}
	if `w' >= 3 {
		di as error  "{err}{cmd:scale()} accepts at most two inputs"  
		exit 125
	}
	******************** Set nbins ***************************
	tokenize `nbins'	
	local w : word count `nbins'
	if `w' == 1 {
		local nbins_r = `"`1'"'
		local nbins_l = `"`1'"'
	}
	if `w' == 2 {
		local nbins_l `"`1'"'
		local nbins_r `"`2'"'
	}
	if `w' >= 3 {
		di as error  "{err}{cmd:nbins()} accepts at most two inputs"  
		exit 125
	}
	********************************************************
	tempvar x_l x_r y_l y_r orig_order miss sample
	qui gen `orig_order' = _n
	qui gen `sample'=.
	qui replace `sample'=_n if `y'!=. & `x'!=. & `touse'
	qui count
	local size=r(N)

	preserve
	sort `sample' `y' `x'
	qui keep if `touse'
	qui drop if `sample'==.
	qui gen `x_l' = `x' if `x'<`c'
	qui gen `y_l' = `y' if `x'<`c'
	qui gen `x_r' = `x' if `x'>=`c'
	qui gen `y_r' = `y' if `x'>=`c'
	qui su `x'
	local x_min = r(min)
	local x_max = r(max)
	local N = r(N)
	qui su `x_l', d
	local n_l = r(N)
	local range_l = abs(`c'-r(min))
	qui su `x_r', d
	local n_r = r(N)
	local range_r = abs(r(max)-`c')
	local n = `n_r' + `n_l'
	qui su `y_l'
	local var_l = r(sd)
	qui su `y_r'
	local var_r = r(sd)
	if ("`h_l'"=="" & "`h_r'"=="") {
		local h_l = `range_l'
		local h_r = `range_r'
	}
	if "`kernel'"=="" local kernel = "uni"
				
	**************************** ERRORS
	if ("`nochecks'"=="") {
			if (`c'<=`x_min' | `c'>=`x_max'){
			 di as error  "{err}{cmd:c()} should be set within the range of `x'"  
			 exit 125
			}

			if ("`p'"<"0"){
			 di as error  "{err}{cmd:p()} should be a positive integer"  
			 exit 411
			}
			
			if ("`k'"<="0"){
			 di as error  "{err}{cmd:k()} should be a positive integer"  
			 exit 411
			}
			
			*if ("`scale_l'"<="0" | "`scale_r'"<="0" | "`nbins_l'"<="0" | "`nbins_r'"<="0"){
			*	di as error  "{err}{cmd:scale()}, {cmd:nbins()} should be positive integers"  
			*	exit 411
			*}

			*if ( ("`scale_l'"!="" | "`scale_r'"!="") &  ("`nbins_l'"!="" | "`nbins_r'"!="") ) {
			*	 di as error  "{err}{cmd:scale()} cannot be combined with {cmd:nbins()}"
			*	 exit 498
			*}
			
			*local p_round    = round(`p')/`p'
			*local p_scale    = round(`scale')/`scale'
			*local p_scale_l  = round(`scale_l')/`scale_l'
			*local p_scale_r  = round(`scale_r')/`scale_r'
			*local p_nbins_l = round(`nbins_l')/`nbins_l'
			*local p_nbins_r = round(`nbins_r')/`nbins_r'

			*if (`p_round'!=1 | `p_scale'!=1 | `p_scale_l'!=1 | `p_scale_r'!=1 | `p_nbins_l'!=1 | `p_nbins_r'!=1 ) {
			*if ( `p_nbins_l'!=1 | `p_nbins_r'!=1 ) {
			*	 di as error  "{err}{cmd:p()}, {cmd:nbins_l()} and {cmd:nbins_r()} should be integers"  
			* exit 126
			*}
	}
	if ("`scale_l'"=="" & "`scale_r'"=="") {
		local scale_r = 1
		local scale_l = 1
	}
	if ("`nbins_l'"=="" & "`nbins_r'"=="") {
		local nbins_r = 0
		local nbins_l = 0
	}

	mata{
	allsample=`size'
	usesample=`n_l'+`n_r'
	n_l=`n_l'
	n_r=`n_r'
	p=`p'
	k=`k'
	n=`n'
	c=`c'
	x_min = `x_min'
	x_max = `x_max'
	n = usesample
	h_l     = strtoreal("`h_l'");     h_r     = strtoreal("`h_r'")
	nbins_l = strtoreal("`nbins_l'"); nbins_r = strtoreal("`nbins_r'")
	scale_l = strtoreal("`scale_l'"); scale_r = strtoreal("`scale_r'")
	y = st_data(.,("`y'"), 0);	x = st_data(.,("`x'"), 0)
	x_l = select(x,x:<c);	x_r = select(x,x:>=c)
	y_l = select(y,x:<c);	y_r = select(y,x:>=c)
	
	************ Polynomial curve (order = p) ****
	rp_l = J(n_l,(p+1),.)
	rp_r = J(n_r,(p+1),.)
	for (j=1; j<=(p+1); j++) {
		rp_l[.,j] = x_l:^(j-1)
		rp_r[.,j] = x_r:^(j-1)
	}

	wh_l = rdrobust_kweight(x_l,c,h_l,"`kernel'")
	wh_r = rdrobust_kweight(x_r,c,h_r,"`kernel'")
	select_l = selectindex(wh_l:> 0)
	select_r = selectindex(wh_r:> 0)
	n_h_l=length(select_l)
	n_h_r=length(select_r)
	gamma_p1_l = invsym(cross(rp_l,wh_l,rp_l))*cross(rp_l, wh_l, y_l)	
	gamma_p1_r = invsym(cross(rp_r,wh_r,rp_r))*cross(rp_r, wh_r, y_r)

	yhat_l = rp_l*gamma_p1_l
	yhat_r = rp_r*gamma_p1_r
		
	X_l = Yhat_l = J(n_l,1,.)
	X_r = Yhat_r = J(n_r,1,.)
	X_l[select_l] = x_l[select_l]
	X_r[select_r] = x_r[select_r]
	Yhat_l[select_l]=yhat_l[select_l]
	Yhat_r[select_r]=yhat_r[select_r]
	
	x_sup = X_l \ X_r
	y_hat = Yhat_l \ Yhat_r	
	
	*******************************************	
	
	**** Optimal Bins (using polynomial order k ***********
	rk_l = J(n_l,(k+1),.)
	rk_r = J(n_r,(k+1),.)
	for (j=1; j<=(k+1); j++) {
		rk_l[.,j] = x_l:^(j-1)
		rk_r[.,j] = x_r:^(j-1)
	}
	gamma_k1_l = invsym(cross(rk_l,rk_l))*cross(rk_l,y_l)		
	gamma_k2_l = invsym(cross(rk_l,rk_l))*cross(rk_l,y_l:^2)	
	gamma_k1_r = invsym(cross(rk_r,rk_r))*cross(rk_r,y_r)		
	gamma_k2_r = invsym(cross(rk_r,rk_r))*cross(rk_r,y_r:^2)
		
	*** Bias w/sample
	mu0_k1_l = rk_l*gamma_k1_l
	mu0_k1_r = rk_r*gamma_k1_r
	mu0_k2_l = rk_l*gamma_k2_l
	mu0_k2_r = rk_r*gamma_k2_r
	drk_l = J(n_l,k,.)
	drk_r = J(n_r,k,.)
	for (j=1; j<=k; j++) {
		drk_l[.,j] = j*x_l:^(j-1)
		drk_r[.,j] = j*x_r:^(j-1)
	}
	

*	if (nbins_l==1 & nbins_r==1 ) {

	ind_l=ind_r=w=0
	order = minindex(x_l, n_l, ind_l, w)
	x_i_l = x_l[ind_l] 
	y_i_l = y_l[ind_l]
	
	order = minindex(x_r, n_r, ind_r, w)
	x_i_r = x_r[ind_r] 
	y_i_r = y_r[ind_r]
	
    dxi_l=(x_i_l[2::length(x_i_l)]-x_i_l[1::(length(x_i_l)-1)])
	dxi_r=(x_i_r[2::length(x_i_r)]-x_i_r[1::(length(x_i_r)-1)])
	dyi_l=(y_i_l[2::length(y_i_l)]-y_i_l[1::(length(y_i_l)-1)])
	dyi_r=(y_i_r[2::length(y_i_r)]-y_i_r[1::(length(y_i_r)-1)])
	
	x_bar_i_l = (x_i_l[2::length(x_i_l)]+x_i_l[1::(length(x_i_l)-1)])/2
	x_bar_i_r = (x_i_r[2::length(x_i_r)]+x_i_r[1::(length(x_i_r)-1)])/2
	
	drk_i_l = J(n_l-1,k,.);	rk_i_l  = J(n_l-1,(k+1),.)
	drk_i_r = J(n_r-1,k,.);	rk_i_r  = J(n_r-1,(k+1),.)
	           
    for (j=1; j<=(k+1); j++) {
     rk_i_l[.,j] = x_bar_i_l:^(j-1)
     rk_i_r[.,j] = x_bar_i_r:^(j-1)
   }
  
 * if (`p'>0 ) {
   for (j=1; j<=k; j++) {
     drk_i_l[.,j] = j*x_bar_i_l:^(j-1)
     drk_i_r[.,j] = j*x_bar_i_r:^(j-1)
   }
   mu1_i_hat_l = drk_i_l*(gamma_k1_l[2::(k+1)])
   mu1_i_hat_r = drk_i_r*(gamma_k1_r[2::(k+1)])
  * }
  * else if (`p'==0){
*	drp_i_l=0
*	drp_i_r=0
*	mu1_i_hat_l = 0
*	mu1_i_hat_r = 0
 *  }
   
   mu0_i_hat_l = rk_i_l*gamma_k1_l
   mu0_i_hat_r = rk_i_r*gamma_k1_r
   mu2_i_hat_l = rk_i_l*gamma_k2_l
   mu2_i_hat_r = rk_i_r*gamma_k2_r

  ******************************

  mu0_hat_l = rk_l*gamma_k1_l
  mu0_hat_r = rk_r*gamma_k1_r
  mu2_hat_l = rk_l*gamma_k2_l
  mu2_hat_r = rk_r*gamma_k2_r
  
  mu1_hat_l = drk_l*(gamma_k1_l[2::(k+1)])
  mu1_hat_r = drk_r*(gamma_k1_r[2::(k+1)])
	
  mu1_i_hat_l = drk_i_l*(gamma_k1_l[2::(k+1)])
  mu1_i_hat_r = drk_i_r*(gamma_k1_r[2::(k+1)])
  
  sigma2_hat_l_bar = mu2_i_hat_l - mu0_i_hat_l:^2
  sigma2_hat_r_bar = mu2_i_hat_r - mu0_i_hat_r:^2

  sigma2_hat_l = mu2_hat_l - mu0_hat_l:^2
  sigma2_hat_r = mu2_hat_r - mu0_hat_r:^2
  
  var_y_l = variance(y_l)
  var_y_r = variance(y_r)

  B_es_hat_dw = (((c-x_min)^2/(12*n))*sum(mu1_hat_l:^2),((x_max-c)^2/(12*n))*sum(mu1_hat_r:^2))
  V_es_hat_dw = ((0.5/(c-x_min))*sum(dxi_l:*dyi_l:^2),(0.5/(x_max-c))*sum(dxi_r:*dyi_r:^2))
  V_es_chk_dw = ((1/(c-x_min))*sum(dxi_l:*sigma2_hat_l_bar),(1/(x_max-c))*sum(dxi_r:*sigma2_hat_r_bar))
  J_es_hat_dw = ceil((((2*B_es_hat_dw):/V_es_hat_dw)*n):^(1/3))
  J_es_chk_dw = ceil((((2*B_es_hat_dw):/V_es_chk_dw)*n):^(1/3))
	
  B_qs_hat_dw = ((n_l^2/(24*n))*sum(dxi_l:^2:*mu1_i_hat_l:^2), (n_r^2/(24*n))*sum(dxi_r:^2:*mu1_i_hat_r:^2))
  V_qs_hat_dw = ((1/(2*n_l))*sum(dyi_l:^2),(1/(2*n_r))*sum(dyi_r:^2))
  V_qs_chk_dw = ((1/n_l)*sum(sigma2_hat_l), (1/n_r)*sum(sigma2_hat_r))
  J_qs_hat_dw = ceil((((2*B_qs_hat_dw):/V_qs_hat_dw)*n):^(1/3))
  J_qs_chk_dw = ceil((((2*B_qs_hat_dw):/V_qs_chk_dw)*n):^(1/3))
  
  J_es_hat_mv  = (ceil((var_y_l/V_es_hat_dw[1])*(n/log(n)^2)), ceil((var_y_r/V_es_hat_dw[2])*(n/log(n)^2)))
  J_es_chk_mv  = (ceil((var_y_l/V_es_chk_dw[1])*(n/log(n)^2)), ceil((var_y_r/V_es_chk_dw[2])*(n/log(n)^2)))
  J_qs_hat_mv  = (ceil((var_y_l/V_qs_hat_dw[1])*(n/log(n)^2)), ceil((var_y_r/V_qs_hat_dw[2])*(n/log(n)^2)))
  J_qs_chk_mv  = (ceil((var_y_l/V_qs_chk_dw[1])*(n/log(n)^2)), ceil((var_y_r/V_qs_chk_dw[2])*(n/log(n)^2)))
  ******************************************************

	if ("`binselect'"=="es" ) {
		J_star_l_orig = J_es_hat_dw[1]
		J_star_r_orig = J_es_hat_dw[2]
	}
	
	if ("`binselect'"=="esmv" | "`binselect'"=="") {
		J_star_l_orig = J_es_hat_mv[1]
		J_star_r_orig = J_es_hat_mv[2]
	}
	
	if ("`binselect'"=="espr" ) {
		J_star_l_orig = J_es_chk_dw[1]
		J_star_r_orig = J_es_chk_dw[2]
	}
	
	if ("`binselect'"=="esmvpr" ) {
		J_star_l_orig = J_es_chk_mv[1]
		J_star_r_orig = J_es_chk_mv[2]
	}
	
	if ("`binselect'"=="qs" ) {
		J_star_l_orig = J_qs_hat_dw[1]
		J_star_r_orig = J_qs_hat_dw[2]
	}
	
	if ("`binselect'"=="qsmv" ) {
		J_star_l_orig = J_qs_hat_mv[1]
		J_star_r_orig = J_qs_hat_mv[2]
	}
	
	if ("`binselect'"=="qspr" ) {
		J_star_l_orig = J_qs_chk_dw[1]
		J_star_r_orig = J_qs_chk_dw[2]
	}
	
	if ("`binselect'"=="qsmvpr" ) {
		J_star_l_orig = J_qs_chk_mv[1]
		J_star_r_orig = J_qs_chk_mv[2]
	}

*	}
*	else {
	if (nbins_l!=0 & nbins_r!=0) {
		J_star_l_orig = nbins_l
		J_star_r_orig = nbins_r
	}
	
	if (`var_l'==0) {
		J_star_l = 1
		J_star_l_orig = 1
		display("{err}Warning: not enough variability in the outcome variable below the threshold")
	}
	if (`var_r'==0) {
		J_star_r = 1
		J_star_r_orig = 1
		display("{err}Warning: not enough variability in the outcome variable above the threshold")
	}

	J_star_l = round(`scale_l'*J_star_l_orig)
	J_star_r = round(`scale_r'*J_star_r_orig)

	st_numscalar("nbins_l", nbins_l)
	st_numscalar("nbins_r", nbins_r)
	st_numscalar("n_h_l", n_h_l)
	st_numscalar("n_h_r", n_h_r)
	st_numscalar("J_star_l", J_star_l)
	st_numscalar("J_star_r", J_star_r)
	st_numscalar("J_star_l_orig", J_star_l_orig)
	st_numscalar("J_star_r_orig", J_star_r_orig)
		
	st_matrix("J_es_hat_dw", J_es_hat_dw)
	st_matrix("J_qs_hat_dw", J_qs_hat_dw)
	st_matrix("J_es_chk_dw", J_es_chk_dw)
	st_matrix("J_qs_chk_dw", J_qs_chk_dw)

	st_matrix("J_es_hat_mv", J_es_hat_mv)
	st_matrix("J_qs_hat_mv", J_qs_hat_mv)
	st_matrix("J_es_chk_mv", J_es_chk_mv)
	st_matrix("J_qs_chk_mv", J_qs_chk_mv)
	}
	
	qui gen id_bin =.

	***** ES Bins
	if ("`binselect'"=="es" | "`binselect'"=="espr"  | "`binselect'"=="esmv" | "`binselect'"=="esmvpr" | "`binselect'"=="" ) {
		local jump_l = `range_l'/J_star_l
		qui su `x_l'
		local x_min = r(min)
		local x_max = r(max)
		qui replace id_bin = -J_star_l  if `x_l' <= (`x_min' + `jump_l') & `x_l'!=. & `y_l'!=.
		qui replace id_bin = -1         if `x_l' >= (`x_max' - `jump_l') & `x_l'!=. & `y_l'!=.
		local K = J_star_l-1
		forvalues k = 2 (1) `K' {
			qui replace id_bin = -J_star_l+`k'-1 if  `x_l' <= `x_min'+`k'*`jump_l' & `x_l' >= `x_min'+(`k'-1)*`jump_l' & `x_l'!=. & `y_l'!=.
		}

		local jump_r = `range_r'/J_star_r
		qui su `x_r'
		local x_min = r(min)
		local x_max = r(max)
		qui replace id_bin = 1        if `x_r' <= (`x_min' + `jump_r') & `x_r'!=. & `y_r'!=.
		qui replace id_bin = J_star_r if `x_r' >= (`x_max' - `jump_r') & `x_r'!=. & `y_r'!=.
		local K = J_star_r-1
		forvalues k = 2 (1) `K' {
			qui replace id_bin = `k' if  `x_r' <= `x_min'+`k'*`jump_r' & `x_r' >= `x_min'+(`k'-1)*`jump_r' & `x_r'!=. & `y_r'!=.
		}
	local binselect_type="Evenly spaced"
	}
		else if ("`binselect'"=="qs" | "`binselect'"=="qspr" |"`binselect'"=="qsmv" |"`binselect'"=="qsmvpr") {
			local J_l = J_star_l
			if (`J_l'>=2) {
				xtile binx_l = `x_l' , nq(`J_l')
				qui replace binx_l=binx_l-`J_l'-1
				qui replace id_bin=binx_l if `x_l'!=.
			}
			else {
				local jump_l = `range_l'/J_star_l
				qui su `x_l'
				local x_min = r(min)
				local x_max = r(max)
				qui replace id_bin = -J_star_l  if `x_l' <= (`x_min' + `jump_l') & `x_l'!=. & `y_l'!=.
				qui replace id_bin = -1         if `x_l' >= (`x_max' - `jump_l') & `x_l'!=. & `y_l'!=.
				local K = J_star_l-1
				forvalues k = 2 (1) `K' {
					qui replace id_bin = -J_star_l+`k'-1 if  `x_l' <= `x_min'+`k'*`jump_l' & `x_l' >= `x_min'+(`k'-1)*`jump_l' & `x_l'!=. & `y_l'!=.
				}
		}
			local J_r = J_star_r
			if (`J_r'>=2) {
				xtile binx_r = `x_r' , nq(`J_r')
				qui replace id_bin=binx_r if `x_r'!=.
			}
			else {
				local jump_r = `range_r'/J_star_r
				qui su `x_r'
				local x_min = r(min)
				local x_max = r(max)
				qui replace id_bin = 1        if `x_r' <= (`x_min' + `jump_r') & `x_r'!=. & `y_r'!=.
				qui replace id_bin = J_star_r if `x_r' >= (`x_max' - `jump_r') & `x_r'!=. & `y_r'!=.
				local K = J_star_r-1
				forvalues k = 2 (1) `K' {
					qui replace id_bin = `k' if  `x_r' <= `x_min'+`k'*`jump_r' & `x_r' >= `x_min'+(`k'-1)*`jump_r' & `x_r'!=. & `y_r'!=.
				}
			}
			local binselect_type="Quantile spaced"
	}

			if ("`binselect'"=="es"){
				local binselect_type="evenly spaced number of bins using spacings estimators."
				scalar J_star_l_IMSE = J_es_hat_dw[1,1]
				scalar J_star_r_IMSE = J_es_hat_dw[1,2]
				scalar J_star_l_MV   = J_es_hat_mv[1,1]
				scalar J_star_r_MV   = J_es_hat_mv[1,2]
			}
	          if ("`binselect'"=="espr"){
				local binselect_type="evenly spaced number of bins using polynomial regression."
				scalar J_star_l_IMSE = J_es_chk_dw[1,1]
				scalar J_star_r_IMSE = J_es_chk_dw[1,2]
				scalar J_star_l_MV   = J_es_chk_mv[1,1]
				scalar J_star_r_MV   = J_es_chk_mv[1,2]
	          }
              if ("`binselect'"=="esmv" | "`binselect'"==""){
				local binselect_type="evenly spaced mimicking variance number of bins using spacings estimators."
				scalar J_star_l_IMSE = J_es_hat_dw[1,1]
				scalar J_star_r_IMSE = J_es_hat_dw[1,2]
				scalar J_star_l_MV   = J_es_hat_mv[1,1]
				scalar J_star_r_MV   = J_es_hat_mv[1,2]
	          }
              if ("`binselect'"=="esmvpr"){
				local binselect_type="evenly spaced mimicking variance number of bins using polynomial regression."
				scalar J_star_l_IMSE = J_es_chk_dw[1,1]
				scalar J_star_r_IMSE = J_es_chk_dw[1,2]
				scalar J_star_l_MV   = J_es_chk_mv[1,1]
				scalar J_star_r_MV   = J_es_chk_mv[1,2]
	          }
              if ("`binselect'"=="qs"){
				local binselect_type="quantile spaced number of bins using spacings estimators."
				scalar J_star_l_IMSE = J_qs_hat_dw[1,1]
				scalar J_star_r_IMSE = J_qs_hat_dw[1,2]
				scalar J_star_l_MV   = J_qs_hat_mv[1,1]
				scalar J_star_r_MV   = J_qs_hat_mv[1,2]
	          }
              if ("`binselect'"=="qspr"){
				local binselect_type="quantile spaced number of bins using polynomial regression."
				scalar J_star_l_IMSE = J_qs_chk_dw[1,1]
				scalar J_star_r_IMSE = J_qs_chk_dw[1,2]
				scalar J_star_l_MV   = J_qs_chk_mv[1,1]
				scalar J_star_r_MV   = J_qs_chk_mv[1,2]
	          }
              if ("`binselect'"=="qsmv"){
				local binselect_type="quantile spaced mimicking variance quantile spaced using spacings estimators."  
				scalar J_star_l_IMSE = J_qs_hat_dw[1,1]
				scalar J_star_r_IMSE = J_qs_hat_dw[1,2]
				scalar J_star_l_MV   = J_qs_hat_mv[1,1]
				scalar J_star_r_MV   = J_qs_hat_mv[1,2]
				}
              if ("`binselect'"=="qsmvpr"){
				local binselect_type="quantile spaced mimicking variance number of bins using polynomial regression."
				scalar J_star_l_IMSE = J_qs_chk_dw[1,1]
				scalar J_star_r_IMSE = J_qs_chk_dw[1,2]
				scalar J_star_l_MV   = J_qs_chk_mv[1,1]
				scalar J_star_r_MV   = J_qs_chk_mv[1,2]
	          }
			  	if (nbins_l!=0 | nbins_r!=0 ) local binselect_type= "RD plot with manually set number of bins."
	
 
	scalar scale_l = J_star_l / J_star_l_IMSE
	scalar scale_r = J_star_r / J_star_r_IMSE

	qui egen meany_bin=mean(`y'), by(id_bin)
	qui egen bin_yN=count(`y'), by(id_bin)
	qui egen bin_ySD=sd(`y'), by(id_bin)
	qui replace bin_ySD=0 if bin_ySD==.
	
	local quant = -invnormal(abs((1-(`ci'/100))/2))
	qui gen cil_bin = meany_bin - `quant'*bin_ySD/sqrt(bin_yN)
	qui gen cir_bin = meany_bin + `quant'*bin_ySD/sqrt(bin_yN)
	
	qui egen maxx_bin=max(`x'), by(id_bin)
	qui egen minx_bin=min(`x'), by(id_bin)
	qui gen meanx_bin=(maxx_bin+minx_bin)/2 
	
	mata{
		id_bin    = st_data(.,("id_bin"), 0)
		meanx_bin = st_data(.,("meanx_bin"), 0)
		meany_bin = st_data(.,("meany_bin"), 0)
		cil_bin   = st_data(.,("cil_bin"), 0)
		cir_bin   = st_data(.,("cir_bin"), 0)
		*bin_yN    = st_data(.,("bin_yN"), 0)
		*bin_ySD   = st_data(.,("bin_ySD"), 0)
		st_store(., st_addvar("float", "x_sup"), x_sup)
		st_store(., st_addvar("float", "y_hat"), y_hat)
		st_matrix("gamma_p1_l", gamma_p1_l)
		st_matrix("gamma_p1_r", gamma_p1_r)
	}

	ereturn clear
	ereturn scalar J_star_l         = J_star_l
	ereturn scalar J_star_r         = J_star_r
	ereturn scalar J_star_l_orig    = J_star_l_orig
	ereturn scalar J_star_r_orig    = J_star_r_orig
	ereturn scalar binlength_l      = `range_l'/J_star_l
	ereturn scalar binlength_r      = `range_r'/J_star_r
	ereturn scalar binlength_l_orig = `range_l'/J_star_l_orig
	ereturn scalar binlength_r_orig = `range_r'/J_star_r_orig
	ereturn matrix gamma_p_l = gamma_p1_l
	ereturn matrix gamma_p_r = gamma_p1_r

	cap drop x_sup_l
	cap drop x_sup_r
	cap drop y_hat_l 
	cap drop y_hat_r
	
	if ("`kernel'"=="epanechnikov" | "`kernel'"=="epa") local kernel_type = "Epanechnikov"
	else if ("`kernel'"=="uniform" | "`kernel'"=="uni") local kernel_type = "Uniform"
	else  local kernel_type = "Triangular"
			
	disp ""
	disp in smcl in yellow "RD Plot with " "`binselect_type'" 
	disp ""
	
	disp in smcl in gr "{ralign 21: Cutoff c = `c'}"      _col(22) " {c |} " _col(23) in gr "Left of " in yellow "c"  _col(36) in gr "Right of " in yellow "c" _col(61) in gr "Number of obs  = "  in yellow %10.0f `n'
	disp in smcl in gr "{hline 22}{c +}{hline 22}"                                                                                                             _col(61) in gr "Kernel         = "  in yellow "{ralign 10:`kernel_type'}" 
	disp in smcl in gr "{ralign 21:Number of obs}"        _col(22) " {c |} " _col(23) as result %9.0f `n_l'      _col(37) %9.0f  `n_r'                        
	disp in smcl in gr "{ralign 21:Eff. Number of obs}"   _col(22) " {c |} " _col(23) as result %9.0f n_h_l      _col(37) %9.0f  n_h_r                        
	disp in smcl in gr "{ralign 21:Order poly. fit (p)}"  _col(22) " {c |} " _col(23) as result %9.0f `p'        _col(37) %9.0f  `p'                              
	disp in smcl in gr "{ralign 21:BW poly. fit (h)}"     _col(22) " {c |} " _col(23) as result %9.3f `h_l'      _col(37) %9.3f  `h_r' 
	disp in smcl in gr "{ralign 21:Number of bins scale}" _col(22) " {c |} " _col(23) as result %9.3f `scale_l'  _col(37) %9.3f  `scale_r' 
	disp ""
	disp "Outcome: `y'. Running variable: `x'."
	disp in smcl in gr "{hline 28}{c TT}{hline 25}"
	disp in smcl in gr   _col(28) " {c |} " _col(33) in gr "Left of " in yellow "c"      _col(45) in gr "Right of " in yellow "c" 
	disp in smcl in gr "{hline 28}{c +}{hline 25}"                                                                                
	disp in smcl in gr "{ralign 27:Selected number of bins}"    _col(28) " {c |} " _col(35) as result %7.0f e(J_star_l)      _col(48) %7.0f  e(J_star_r)
	disp in smcl in gr "{ralign 27:Bin length}"                 _col(28) " {c |} " _col(35) as result %7.3f e(binlength_l)   _col(48) %7.3f  e(binlength_r)
	disp in smcl in gr "{hline 28}{c +}{hline 25}"  
	disp in smcl in gr "{ralign 27:IMSE-optimal bins}"          _col(28) " {c |} " _col(35) as result %7.0f J_star_l_IMSE    _col(48) %7.0f  J_star_r_IMSE
	disp in smcl in gr "{ralign 27:Mimicking Variance bins}"    _col(28) " {c |} " _col(35) as result %7.0f J_star_l_MV      _col(48) %7.0f  J_star_r_MV
	disp in smcl in gr "{hline 28}{c +}{hline 25}"    
	disp in smcl in gr "{lalign 1:Relative to IMSE-optimal:}"   _col(28) " {c |} " 
	disp in smcl in gr "{ralign 27:Implied scale}"              _col(28) " {c |} " _col(35) as result %7.3f scale_l                 _col(48) %7.3f  scale_r
	disp in smcl in gr "{ralign 27:WIMSE variance weight}"      _col(28) " {c |} " _col(35) as result %7.3f 1/(1+scale_l^3)         _col(48) %7.3f  1/(1+scale_r^3)
   	disp in smcl in gr "{ralign 27:WIMSE bias weight}"          _col(28) " {c |} " _col(35) as result %7.3f scale_l^3/(1+scale_l^3) _col(48) %7.3f  scale_r^3/(1+scale_r^3)
	disp in smcl in gr "{hline 28}{c BT}{hline 25}"    
	
	disp ""
	if ("`hide'"==""){
		if ("`graph_options'"=="" ) local graph_options = `"title("Regression function fit", color(gs0)) "'
		if (`ci'==0) {
				twoway (scatter meany_bin meanx_bin, sort msize(small)  mcolor(gs10)) ///
				(line y_hat x_sup if x_sup<`c',  lcolor(black) sort lwidth(medthin) lpattern(solid) ) ///
				(line y_hat x_sup if x_sup>=`c', lcolor(black) sort lwidth(medthin) lpattern(solid) ),  ///
				xline(`c', lcolor(black) lwidth(medthin)) xscale(r(`x_min' `x_max'))  legend(cols(2) order(1 "Sample average within bin" 2 "Polynomial fit of order `p'" )) `graph_options'
		}
		else {
			if ("`shade'"==""){
				twoway (rcap cil_bin cir_bin meanx_bin, color(gs11)) ///
				(scatter meany_bin meanx_bin, sort msize(small)  mcolor(gs10)) ///
				(line y_hat x_sup if x_sup<`c',  lcolor(black) sort lwidth(medthin) lpattern(solid))   ///
				(line y_hat x_sup if x_sup>=`c', lcolor(black) sort lwidth(medthin) lpattern(solid)),  ///
				xline(`c', lcolor(black) lwidth(medthin)) xscale(r(`x_min' `x_max')) legend(cols(2) order(2 "Sample average within bin" 3 "Polynomial fit of order `p'" )) `graph_options'
			}
			else {
				twoway (rarea cil_bin cir_bin meanx_bin, sort color(gs11)) ///
				(scatter meany_bin meanx_bin, sort msize(small)  mcolor(gs10)) ///
				(line y_hat x_sup if x_sup<`c',  lcolor(black) sort lwidth(medthin) lpattern(solid)) ///
				(line y_hat x_sup if x_sup>=`c', lcolor(black) sort lwidth(medthin) lpattern(solid)) ,  ///
				xline(`c', lcolor(black) lwidth(medthin)) xscale(r(`x_min' `x_max')) legend(cols(2) order(2 "Sample average within bin" 3 "Polynomial fit of order `p'" )) `graph_options'
			}						
		}
	}
	
	restore
	sort `sample'

	mata{
		if ("`nsave'"=="1") {
			if (allsample!=usesample){
				miss = J(allsample-usesample,1, .)
				id_bin=(id_bin',miss')'
		}

		st_store(., st_addvar("float", "`id_var'"), id_bin)
		}

		if ("`nsave'"=="2") {
			if (allsample!=usesample){
				miss = J(allsample-usesample,1, .)
				id_bin=(id_bin',miss')'
				meanx_bin=(meanx_bin',miss')'
			}
			st_store(., st_addvar("float", "`id_var'"),    id_bin )
			st_store(., st_addvar("float", "`meanx_var'"), meanx_bin )
		}

		if ("`nsave'"=="3") {
			if (allsample!=usesample){
				miss = J(allsample-usesample,1, .)
				id_bin=(id_bin',miss')'
				meanx_bin=(meanx_bin',miss')'
				meany_bin=(meany_bin',miss')'
			}
			st_store(., st_addvar("float", "`id_var'"),    id_bin )
			st_store(., st_addvar("float", "`meanx_var'"), meanx_bin )
			st_store(., st_addvar("float", "`meany_var'"), meany_bin )
			}
		
		if ("`nsave'"=="5") {
			if (allsample!=usesample){
				miss      = J(allsample-usesample,1, .)
				id_bin    = (id_bin',miss')'
				meanx_bin = (meanx_bin',miss')'
				meany_bin = (meany_bin',miss')'
				cil_bin   = (cil_bin',miss')'
				cir_bin   = (cir_bin',miss')'
			}
			st_store(., st_addvar("float", "`id_var'"),    id_bin)
			st_store(., st_addvar("float", "`meanx_var'"), meanx_bin)
			st_store(., st_addvar("float", "`meany_var'"), meany_bin)
			st_store(., st_addvar("float", "`cil_var'"),   cil_bin)
			st_store(., st_addvar("float", "`cir_var'"),   cir_bin)
		}
	}	
	sort `orig_order'
	qui drop `sample' `orig_order'
	mata mata clear

end


 
