function [gmmSE, gmmVar] = compute_std_errors(paramsStruct_arg, G)

%%

    % Local parameters.
    sampSize = 8e5; % approx. pre- and post-PPS pooled sample size.

    W_0 = paramsStruct_arg.W_0;
    % Not needed for now since we set the correction term (involving
    % error_match) to zero
    % moments = paramsStruct_arg.moments;
    % moments_hat = retStruct_arg.moments_hat;
    % error_match = moments - moments_hat;

    % Bootstrapped var-cov matrix.
    bootstrap_var_m_hat = paramsStruct_arg.bootstrap_var_m_hat;
    % var(m_i); m = sample moment, i indexes patients
    var_m_i = sampSize * bootstrap_var_m_hat;
    % omega = var(g_i(theta_hat))
    % omega = var_m_i + error_match * error_match';
    omega = var_m_i; % set the correction term (involving error_match) to zero

    % Asymptotic GMM variance (i.e. after applying CLT) of theta (params vector)
    % sqrt(N)(theta_GMM - theta)
    % K X K; K = number of params.
    gmmVar = ((G' * W_0 * G) \ G' * W_0 * omega * W_0 * G) / (G' * W_0 * G);

    % Standard error (make this a row vector).
    gmmSE = sqrt(diag(gmmVar/sampSize))';


end