function [a_pre_hat, s_pre_hat, a_post_hat, s_post_hat] = ...
    estimate_post_ltch_payments(nonltchPayModel, ...
    z_pre, z_post, h_a_dist_pre, h_s_dist_pre, h_a_dist_post, h_s_dist_post, ...
    params_all, paramsStruct)

    %extract zeta parameters from params_all
    [~, ~, ~, ~, zeta_a_pre, zeta_s_pre, zeta_a_post, zeta_s_post] ...
          = assign_params(params_all, paramsStruct);
      
    % Pre-period
    if ~paramsStruct.ind_omitPrePPSNonLtch  
        %upstream
        spec_a = nonltch_spec(nonltchPayModel, zeta_a_pre, z_pre, h_a_dist_pre);
    
        %downstream
        spec_s = nonltch_spec(nonltchPayModel, zeta_s_pre, z_pre, h_s_dist_pre); 
        
        % Update estimated moments
        a_pre_hat = paramsStruct.nonLtchPayAggMat_a_pre * spec_a;
        s_pre_hat = paramsStruct.nonLtchPayAggMat_s_pre * spec_s;
    else
        a_pre_hat = [];
        s_pre_hat = [];
    end    
    % Post-period
    
    %upstream
    spec_a = nonltch_spec(nonltchPayModel, zeta_a_post, z_post, h_a_dist_post);

    %downstream
    spec_s = nonltch_spec(nonltchPayModel, zeta_s_post, z_post, h_s_dist_post); 

    % Update estimated moments
    a_post_hat = paramsStruct.nonLtchPayAggMat_a_post * spec_a;
    s_post_hat = paramsStruct.nonLtchPayAggMat_s_post * spec_s;

end