function [W_prime, Q_prime, l_prime, a, s, l]  = ...
    log_sum(V_A, V_S, flow, W, PD, beta, param_scale, trim, valFuncCeil, valFuncFloor)


    % Continuation value at ACH/upstream
    a = V_A(1,:);
    % Continuation value at SNF/downstream
    s = V_S(1,:);
    % Flow + Continuation at LTCH
    l = flow + beta*W(1,:)*PD(:,:)';

    a = a/param_scale; s = s/param_scale; l = l/param_scale;

    % trim large utility values  
    if trim==1
        a = max(min(a,valFuncCeil),valFuncFloor);
        s = max(min(s,valFuncCeil),valFuncFloor);
        l = max(min(l,valFuncCeil),valFuncFloor);
    end

    %logit
    esum = exp(a) + exp(s) + exp(l);
    q_a = exp(a)./esum;
    q_s = exp(s)./esum;
    q_l = exp(l)./esum;

    % log sum formula
    W_prime = param_scale*log(exp(a(2:end)) + exp(s(2:end)) + exp(l(2:end)));
    Q_prime = [q_a(2:end)' q_s(2:end)' q_l(2:end)'];
    l_prime = l(2:end);

end