%specification of post-ltch payment or days
% allows for both lienar and quadratic specification
function nonltch_spec = nonltch_spec(nonltchPayModel, coef, z, healthDist)

coef0=coef(1);
coef1=coef(2);

switch(nonltchPayModel)
    case('nlgmm')
        if length(coef)==3
            %allow the option to fit a quadratic specification
            coef2=coef(3);
            nonltch_spec = healthDist*exp(coef0 + coef1 * z + coef2 * z.^2)';  
        else
            %base case linear specification
            nonltch_spec = healthDist*exp(coef0 + coef1 * z)';
        end
    case('lin')
        nonltch_spec = (coef0 + coef1*healthDist*z');
    otherwise
        frprintf('Invalid nonltchPayModel: %s', nonltchPayModel)
        return
        
end