function [Q_a, Q_s, Q_l, a_threshold, s_threshold, z_a, z_s] = ...
    policy_threshold(Q_preSSO, q_postSSO, z, backInductT, TT)

    % Combine pre- and post-SSO discharge probability matrices.
    Q_a = [squeeze(Q_preSSO(:,:,1));  ones(TT-backInductT+1,1)*q_postSSO(:,1)'];
    Q_s = [squeeze(Q_preSSO(:,:,2));  ones(TT-backInductT+1,1)*q_postSSO(:,2)'];
    Q_l = [squeeze(Q_preSSO(:,:,3));  ones(TT-backInductT+1,1)*q_postSSO(:,3)'];

    % a_threshold gives the column index of value closest to 0.5 in each row of Q_a
    % s_threshold gives the column index of value closest to 0.5 in each row of Q_s
    [~,a_threshold] = min(abs(Q_a(:, 2:end) - 0.5),[],2);    
    [~,s_threshold] = min(abs(Q_s(:, 2:end) - 0.5),[],2);    

    z_a = z(a_threshold);
    z_s = z(s_threshold);

end